package com.unis.module.coding.dal.mysql.dwxx;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.unis.framework.common.pojo.PageResult;
import com.unis.framework.mybatis.core.query.LambdaQueryWrapperX;
import com.unis.framework.mybatis.core.mapper.BaseMapperX;
import com.unis.module.coding.controller.admin.delivery.vo.DeliveryPageReqVO;
import com.unis.module.coding.controller.admin.delivery.vo.DeliveryRespVO;
import com.unis.module.coding.controller.admin.delivery.vo.StorePageReqVO;
import com.unis.module.coding.controller.admin.delivery.vo.StoreRespVO;
import com.unis.module.coding.dal.dataobject.dwxx.DwxxDO;
import org.apache.ibatis.annotations.Mapper;
import com.unis.module.coding.controller.admin.dwxx.vo.*;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 单位信息 Mapper
 *
 * @author 超级管理员
 */
@SuppressWarnings("all")
@Mapper
public interface DwxxMapper extends BaseMapperX<DwxxDO> {

    default PageResult<DwxxDO> selectPage(DwxxPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<DwxxDO>()
                .eqIfPresent(DwxxDO::getDwmc, reqVO.getDwmc())
                /*.eqIfPresent(DwxxDO::getTyxydm, reqVO.getTyxydm())
                .eqIfPresent(DwxxDO::getFddbr, reqVO.getFddbr())
                .eqIfPresent(DwxxDO::getSfzh, reqVO.getSfzh())
                .eqIfPresent(DwxxDO::getLxfs, reqVO.getLxfs())
                .eqIfPresent(DwxxDO::getZcrq, reqVO.getZcrq())
                .eqIfPresent(DwxxDO::getSheng, reqVO.getSheng())
                .eqIfPresent(DwxxDO::getYzbm, reqVO.getYzbm())
                .eqIfPresent(DwxxDO::getZcdz, reqVO.getZcdz())
                .eqIfPresent(DwxxDO::getQyxz, reqVO.getQyxz())
                .eqIfPresent(DwxxDO::getJd, reqVO.getJd())
                .eqIfPresent(DwxxDO::getWd, reqVO.getWd())
                .eqIfPresent(DwxxDO::getResid, reqVO.getResid())
                .eqIfPresent(DwxxDO::getSbzt, reqVO.getSbzt())
                .eqIfPresent(DwxxDO::getSfzx, reqVO.getSfzx())
                .eqIfPresent(DwxxDO::getShzt, reqVO.getShzt())
                .eqIfPresent(DwxxDO::getBz, reqVO.getBz())
                .betweenIfPresent(DwxxDO::getCreateTime, reqVO.getCreateTime())
                .eqIfPresent(DwxxDO::getShi, reqVO.getShi())
                .eqIfPresent(DwxxDO::getXian, reqVO.getXian())
                .eqIfPresent(DwxxDO::getJtdz, reqVO.getJtdz())
                .eqIfPresent(DwxxDO::getCreatorDeptId, reqVO.getCreatorDeptId())
                .eqIfPresent(DwxxDO::getDwDeptId, reqVO.getDwDeptId())
                .eqIfPresent(DwxxDO::getBgzt, reqVO.getBgzt())
                .eqIfPresent(DwxxDO::getSbid, reqVO.getSbid())
                .eqIfPresent(DwxxDO::getSjly, reqVO.getSjly())
                .eqIfPresent(DwxxDO::getXzqhdm, reqVO.getXzqhdm())
                .eqIfPresent(DwxxDO::getZczb, reqVO.getZczb())
                .eqIfPresent(DwxxDO::getZcze, reqVO.getZcze())
                .eqIfPresent(DwxxDO::getQylxr, reqVO.getQylxr())
                .eqIfPresent(DwxxDO::getBgdh, reqVO.getBgdh())
                .eqIfPresent(DwxxDO::getQyemail, reqVO.getQyemail())
                .eqIfPresent(DwxxDO::getQywzdz, reqVO.getQywzdz())
                .eqIfPresent(DwxxDO::getCzhm, reqVO.getCzhm())
                .eqIfPresent(DwxxDO::getSjdwmc, reqVO.getSjdwmc())
                .eqIfPresent(DwxxDO::getSjdwtybm, reqVO.getSjdwtybm())
                .eqIfPresent(DwxxDO::getKqnum, reqVO.getKqnum())
                .eqIfPresent(DwxxDO::getCfnum, reqVO.getCfnum())
                .eqIfPresent(DwxxDO::getYgnum, reqVO.getYgnum())
                .eqIfPresent(DwxxDO::getDwzt, reqVO.getDwzt())*/
                .orderByDesc(DwxxDO::getId));
    }

    Page<DeliveryRespVO> selectWrapperPage(Page<Object> objectPage, @Param("pageReqVO") DeliveryPageReqVO pageReqVO);

    Page<DeliveryRespVO> selectWrapperPageForSheng(Page<Object> objectPage, @Param("pageReqVO") DeliveryPageReqVO pageReqVO);

    Page<DeliveryRespVO> selectWrapperPageForBank(Page<Object> objectPage, @Param("pageReqVO") DeliveryPageReqVO pageReqVO);

    List<StoreRespVO> getStoreListForNation(@Param("pageReqVO") StorePageReqVO pageReqVO);
}